# ********************************************************************************
# *         WARNING: This file is automatically generated by unasync.py.         *
# *                             DO NOT MANUALLY EDIT                             *
# *         Source File: patent_client/_async/uspto/odp/manager_test.py          *
# ********************************************************************************


from .manager import USApplicationBiblioManager, USApplicationManager


def test_all_apps():
    manager = USApplicationManager().filter(query=dict())
    assert manager.count() > 1000


def test_get_one_app():
    app = USApplicationManager().get(q="applicationNumberText:16123456")
    assert app is not None
    assert app.appl_id == "16123456"


def test_get_app_from_search_result():
    manager = USApplicationBiblioManager()
    result = manager.get(q="applicationNumberText:16123456")
    application = result.application
    assert application.appl_id == "16123456"


def test_get_app_biblio_from_search_result():
    manager = USApplicationBiblioManager()
    result = manager.get(q="applicationNumberText:16123456")
    biblio = result.biblio
    assert biblio.appl_id == "16123456"


def test_get_continuity_from_search_result():
    manager = USApplicationBiblioManager()
    result = manager.get(q="applicationNumberText:16123456")
    continuity = result.continuity
    assert len(continuity.child_continuity) > 0


def test_get_documents_from_search_result():
    manager = USApplicationBiblioManager()
    result = manager.get(q="applicationNumberText:16123456")
    documents = result.documents
    assert documents.count() > 0


def test_simple_keyword_searches():
    manager = USApplicationManager()
    result = manager.get("16123456")
    assert result.appl_id == "16123456"


def test_combination_search():
    manager = USApplicationManager()
    result = manager.filter(invention_title="Hair Dryer", filing_date_gte="2020-01-01")
    assert result.count() > 5
